$( document ).ready(function(){
	initialise();
	$(".add").each(function(){
		var d = $(this).attr('id').split("_");
		$(this).bind('click touch', function() {
			add(d[3], 'cell_' + d[1] + '_' + d[2], true);
		});
	});
	$(".fl").each(function(){
		var id = $(this).parent().attr('id');
		$(this).bind('click touch', function() {
			if ($(this).attr('class').match(/liberer/)) {
				liberer_une(id);
			}
			else {
				figer_une(id, 1);
			}
		});
	});
	$("#help_button").bind("mouseenter touch", function(){
		afficher_aide();
	});
	$("#help").bind("click touch", function(){
		afficher_aide();
	});
	$(".log_titre").bind("click touch", function(){
		eval($(this).attr('id'))();
	});
});


var col = new Array();
var row = new Array();
var sq = new Array();
var Case = new Array();
var cell_fin = new Array();
var figee = new Array();
var fin_jeu;

function initialise() {
	fin_jeu = 0;
	for (i=1; i<=9; i++ ) {
		col[i] = new Array();
		row[i] = new Array();
		sq[i] = new Array();
		Case[i] = new Array();
		cell_fin[i] = new Array();
		figee[i] = new Array();
		col[i][0] = 1;
		row[i][0] = 1;
		sq[i][0] = 1;
		for (j=1; j<=9; j++ ) {
			col[i][j] = 0;
			row[i][j] = 0;
			sq[i][j] = 0;
			cell_fin[i][j] = 0;
			figee[i][j] = 0;
			Case[i][j] = new Array();
			for (k=1; k<=9; k++ ) {
				Case[i][j][k] = 1;
			}
		}
	}
	var mode_auto = document.sudoku_options.type_action[1];
	if (mode_auto.disabled == true) {
		mode_auto.disabled = false ;
	}
	document.sudoku_options.type_action[0].checked = true;
}
var legende = new Array("", "A", "B", "C", "D", "E", "F", "G", "H", "I");
var methode = "manuel" ;	

function zero(cellule, old, valeur, verifier) {
	var verif = $("#" + cellule + " .result");
	var valeur = verif.html();
	if (valeur == 0) {
		verif.hide();
	}
	if (old != 0) {
		affich(cellule, old, 1, verifier);
	}
	if (valeur != 0) {
		verif.show();
		affich(cellule, valeur, 0, verifier);
	}
}
	
function affich(cellule, valeur, affich, verifier) {
	var visibilite;
	if (affich == 1) {
		mode_aff = 'afficher';
		visibilite = "inline";
		no_visibilite = "none";
	}
	else {
		mode_aff = 'masquer';
		visibilite = "none";
		no_visibilite = "inline";
	}		
	
	var coord = cellule.split('_');
	// x = coord[1] = numero de colonne
	// y = coord[2] = numero de ligne
	var x = coord[1];
	var y = coord[2];
	var def_carre = Math.ceil(x / 3) + 3 * Math.ceil(y / 3) - 3;
	var x_cell = (x - 1)%3 + 1;
	var y_cell = (y - 1)%3 + 1;	
	var colonne, ligne, carre, ref;
	ref = (valeur * 2) - 1;
	// console.log(mode_aff + ':#c_'+ x + "_" + y + "_" + valeur);
	$("#c_" + x + "_" + y + "_" + valeur).toggle();
	$("#c_" + x + "_" + y + "_" + valeur).prev().toggle();
	Case[x][y][valeur] = affich;
	for (a=1; a<=9; a++ ) {
		colonne = $('#c_' + x + '_' + a + "_" + valeur);
		carre = Math.ceil(x / 3) + 3 * Math.ceil(a / 3) - 3;
		if (row[a][valeur]==0 && Case[x][a][valeur] != affich && (sq[carre][valeur]==0 || carre == def_carre)) {
			// console.log(mode_aff + ':colonne #c_'+ x + "_" + a + "_" + valeur);
			ref = (valeur * 2) - 1;
			colonne.toggle();
			colonne.prev().toggle();
			Case[x][a][valeur] = affich;
		}
		ligne = $('#c_' + a + '_' + y + "_" + valeur);
		carre = Math.ceil(a / 3) + 3 * Math.ceil(y / 3) - 3;
		if (col[a][valeur]==0 && Case[a][y][valeur] != affich && (sq[carre][valeur]==0 || carre == def_carre)) {
			// console.log(mode_aff + ':ligne #c_' + a + '_' + y + "_" + valeur);
			ref = (valeur * 2) - 1;
			ligne.toggle();
			ligne.prev().toggle();
			Case[a][y][valeur] = affich;
		}
	}
	for (xx=(x - x_cell + 1); xx<(x - x_cell + 4); xx++ ) {
		for (yy=(y - y_cell + 1); yy<(y - y_cell + 4); yy++ ) {
			cell = $('#c_' + xx + '_' + yy + "_" + valeur);
			if (col[xx][valeur]==0 && row[yy][valeur]==0 && Case[xx][yy][valeur] != affich) {
				// console.log(mode_aff + ':cell #c_' + xx + '_' + yy + "_" + valeur);
				ref = (valeur * 2) - 1;
				cell.toggle();
				cell.prev().toggle();
				Case[xx][yy][valeur] = affich;
			}
		}
	}
	if (verifier == true) {		
		test_result();
	}
}
function add(valeur, cellule, verifier) {
	var coord = cellule.split('_');
	var x = coord[1];
	var y = coord[2];
	var def_carre = Math.ceil(x / 3) + 3 * Math.ceil(y / 3) - 3;
	var add_nb = $("#" + cellule);
	var old = add_nb.find('.result').html();
	if (old != 0 || valeur != 0) {
		add_nb.find('.result').html(valeur);	
		if (valeur == 0) {
			add_nb.find('.fl').hide();
		}
		else {
			add_nb.find('.figer').show();
		}
		col[x][valeur] = 1;
		row[y][valeur] = 1;
		sq[def_carre][valeur] = 1;
		col[x][old] = 0;
		row[y][old] = 0;
		sq[def_carre][old] = 0;
		cell_fin[x][y] = valeur;
		var style, text_log ;
		if (verifier == true) {
			if (valeur == 0 && old != 0) {
				text_log = " - '" + old + "'";
				style = 'violet';
			}
			else if (old != 0 && valeur != 0) {
				text_log = "'" + old + "' - > '" + valeur + "'" ;
				style = 'bleu';
			}
			else {
				text_log = " + '" + valeur + "'" ;
				style = 'vert';
			}
			text_log += " en \"" + legende[x] + y + "\"" ;
			log(text_log, style);
		}
		zero(cellule, old, valeur, verifier);
	}
}
function test_result() {
	var test = 0;
	var nb_seul = 0;
	var erreurs = new Array();
	var uniques = new Array();
	var ligne_verif = new Array();
	var colonne_verif = new Array();
	var case_verif = new Array();
	var valeur_affich, c, methode, def_carre;
	var err = 0;
	var uni = 0;
	var u_old = 0;
	var nb_total = 0;
	var mode_auto = document.sudoku_options.type_action[1];
	var cell_prov = new Array();
	// Remise  zro des valeurs provisoires
	for (a=1; a<=9; a++ ) {
		cell_prov[a] = new Array();
		ligne_verif[a] = new Array();
		colonne_verif[a] = new Array();
		case_verif[a] = new Array();
		for (b=1; b<=9; b++ ) {
			cell_prov[a][b] = 0;
			ligne_verif[a][b] = 0;
			colonne_verif[a][b] = 0;
			case_verif[a][b] = 0;
		}
	}
	
	for (i=0; i<document.sudoku_options.type_action.length; i++ ) {
		if (document.sudoku_options.type_action[i].checked == true) 
			methode = document.sudoku_options.type_action[i].value;
	}

	/* test par ligne et colonne pour voir si un chiffre se retrouve seul,
	quel que soit le nombre de possibilits dans la cellule 
	Au passage, on teste le nombre de cellules remplies... */
	for (x=1; x<=9; x++ ) {
		for (y=1; y<=9; y++ ) {
			valeur_affich = cell_fin[x][y];
			if (valeur_affich == 0) {
				def_carre = Math.ceil(x / 3) + 3 * Math.ceil(y / 3) - 3;
				for (nb=1; nb<=9; nb++ ) { 
					ligne_verif[y][nb] += Case[x][y][nb];
					colonne_verif[x][nb] += Case[x][y][nb];
					case_verif[def_carre][nb] += Case[x][y][nb];
				}
			}
			else nb_total++ ;
		}
	}
	if (nb_total < 81) {
		// inutile de faire ces tests si toutes les cellules sont remplies !
		// Test pour les colonnes et les lignes
		for (a=1; a<=9; a++ ) {
			test = 0;
			for (nb=1; nb<=9; nb++ ) {
				if (colonne_verif[a][nb] == 1) {
					for (b=1; b<=9; b++ ) {					
						if (Case[a][b][nb] == 1 && cell_fin[a][b] == 0 && cell_prov[a][b] == 0) {
							u_old = 0;
							for (u=0; u<uni; u++ ) {
								if (uniques[u]["x"] == a && uniques[u]["y"] == b ) u_old++ ;
							}
							if (u_old == 0) {
								cell_prov[a][b] == nb;
								uniques[uni] = new Array();
								uniques[uni]["x"] = a;
								uniques[uni]["y"] = b;
								uniques[uni]["value"] = nb;
								uni++ ;
							}
						}
					}				
				}
				if (ligne_verif[a][nb] == 1) {
					for (b=1; b<=9; b++ ) {					
						if (Case[b][a][nb] == 1 && cell_fin[b][a] == 0 && cell_prov[b][a] == 0) {
							u_old = 0;
							for (u=0; u<uni; u++ ) {
								if (uniques[u]["x"] == b && uniques[u]["y"] == a ) u_old++ ;
							}
							if (u_old == 0) {
								cell_prov[b][a] == nb;
								uniques[uni] = new Array();
								uniques[uni]["x"] = b;
								uniques[uni]["y"] = a;
								uniques[uni]["value"] = nb;
								uni++ ;						
							}
						}
					}				
				}
			}
		}
		// Test pour les groupes de 9 cellules
		for (x=1; x<=9; x++ ) {
			for (y=1; y<=9; y++ ) {
				def_carre = Math.ceil(x / 3) + 3 * Math.ceil(y / 3) - 3;
				for (nb=1; nb<=9; nb++ ) {
					if (case_verif[def_carre][nb] == 1) {
						if (Case[x][y][nb] == 1 && cell_fin[x][y] == 0 && cell_prov[x][y] == 0) {
							u_old = 0;
							for (u=0; u<uni; u++ ) {
								if (uniques[u]["x"] == x && uniques[u]["y"] == y ) u_old++ ;
							}
							if (u_old == 0) {
								cell_prov[x][y] == nb;
								uniques[uni] = new Array();
								uniques[uni]["x"] = x;
								uniques[uni]["y"] = y;
								uniques[uni]["value"] = nb;
								uni++ ;						
							}
						}
					}				
				}
			}
		}
		
		for (x=1; x<=9; x++ ) {
			for (y=1; y<=9; y++ ) {
				test = 0;
				valeur_affich = cell_fin[x][y];
				for (nb=1; nb<=9; nb++ ) { 
					// test par cellule pour voir si un chiffre se retrouve seul, ou s'il n'y a plus aucune possibilit
					test +=	Case[x][y][nb];
					if (Case[x][y][nb] == 1) {
						nb_seul = nb;
					}
				}
				if (test == 0 && valeur_affich == 0) {
					// plus aucune possibilit dans la cellule
					erreurs[err] = new Array();
					erreurs[err]["x"] = x;
					erreurs[err]["y"] = y;
					err++ ;
				}
				if (test == 1 && valeur_affich == 0 && cell_prov[x][y] == 0) {
					// valeur unique dans une cellule non remplie
					u_old = 0;
					for (u=0; u<uni; u++ ) {
						if (uniques[u]["x"] == x && uniques[u]["y"] == y) 
							u_old++ ;
					}
					if (u_old == 0) {
						cell_prov[x][y] = nb_seul;
						uniques[uni] = new Array();
						uniques[uni]["x"] = x;
						uniques[uni]["y"] = y;
						uniques[uni]["value"] = nb_seul;
						uni++ ;
					}
				}
			}
		}
		if (erreurs.length == 0 && mode_auto.disabled == true) {
			mode_auto.disabled = false;	
			alert("Mode \"Automatique\" \u00e0 nouveau op\u00e9rationnel...");
		}
		if (erreurs.length > 0) {
			for (i=0; i<erreurs.length; i++ ) {
				log("Blocage en \"" + legende[erreurs[i]["x"]] + erreurs[i]["y"] + "\" !", 'rouge');
				if (mode_auto.disabled == false) {
					alert("Mode \"Automatique\" d\u00e9sactiv\u00e9");
				}
				mode_auto.disabled = true;
				document.sudoku_options.type_action[0].checked = true;
			}
		}
		else if (uniques.length > 0) {
			for (i=0; i<uniques.length; i++ ) {
				if (fin_jeu == 0) {
					log("'" + uniques[i]["value"] + "' forc\u00e9 en \"" + legende[uniques[i]["x"]] + uniques[i]["y"] + "\"", 'orange');
					if (methode == "auto" && cell_fin[uniques[i]["x"]][uniques[i]["y"]] == 0) {
						add(uniques[i]["value"], "cell_" + uniques[i]["x"] + "_" + uniques[i]["y"], true);
					}
				}
			}
		}
	}
	else {
		fin_jeu = 1;
		log("Partie termin\u00e9e !", "rouge");
		alert("Partie termin\u00e9e... Vous avez gagn\u00e9 !");
	}
}
function log(text_log, style) {
	var LOGS = $("#log_file");
	var noeuds = LOGS.children().length;
	var LOG = '<div class="' + style + '">';
	LOG += '<div class="nb_log">' + (noeuds + 1) + ".</div>";
	LOG += '<div class="log_txt">' + text_log + "</div>";
	LOG += "</div>";
	if (noeuds > 0) {
		LOGS.children().first().before(LOG);
	}
	else {
		LOGS.html(LOG);
	}
}

function figer() {
	var n = 0;
	if (fin_jeu == 0) {
		for (x=1; x<=9; x++ ) {
			for (y=1; y<=9; y++ ) {
				n += figer_une('cell_' + x + '_' + y, 0);
			}
		}
		if (n == 1) {
			log( + n + " case fig\u00e9e", "bleu");
		}
		else if (n > 1) {
			log( + n + " cases fig\u00e9es", "bleu");
		}
	}
	else {
		alert("La partie est finie... Cette action est inutile !");
	}
}

function figer_une(cellule, aff) {
	var coord = cellule.split('_');
	var x = coord[1];
	var y = coord[2];
	// CaseFigee = document.getElementById('cell_' + x + '_' + y);
	CaseFigee = $("#" + cellule);
	valeur_affich = CaseFigee.find(".result").html();
	if (valeur_affich != 0 && figee[x][y] == 0) {					
		CaseFigee.find(".bandeau").hide();
		CaseFigee.find(".liberer").show();
		CaseFigee.css({background: "#FAFAFA"});
		CaseFigee.find(".result").css({fontWeight: "bold"});
		figee[x][y] = valeur_affich;
		if (aff == 0) {
			return 1;	
		}
		else {
			log("Case fig\u00e9e sur '" + valeur_affich + "' en \"" + legende[x] + y + "\"", "bleu");		
		}
	}
	return 0;
}
	
function liberer_une(cellule) {
	var coord = cellule.split('_');
	var x = coord[1];
	var y = coord[2];
	CaseFigee = $("#" + cellule);					
	CaseFigee.find(".bandeau").show();
	CaseFigee.css({background: "#EFEFEF"});
	CaseFigee.find(".result").css({fontWeight: "normal"});
	CaseFigee.find(".liberer").hide();
	CaseFigee.find(".figer").show();
	figee[x][y] = 0;
	log("\> Case lib\u00e9r\u00e9e en \"" + legende[x] + y + "\"", "bleu");
}
	
function afficher_aide() {
	var signe = $("#help_button").attr('class');
	var txt = {
		t: "Masquer l'aide",
		v: "&lt;",  
	};
	if (signe == "plus") {
		$("#help_button").attr('class', 'moins');
		$("#aide").animate({marginLeft: '0'});
	}
	else {
		$("#help_button").attr('class', 'plus');
		$("#aide").animate({marginLeft: '-420px'});
		txt = {
			t: "Afficher l'aide",
			v: "&gt;",  
		};
	}
	$("#help_button").html(txt.v);
	$("#help").html(txt.t);
	$("div[id^='help']").attr("title", txt.t);
}

function raz() {
	document.getElementById('log_file').innerHTML = "";
	var old_figee = new Array();
	var n = 0;
	for (x=1; x<=9; x++ ) {
		for (y=1; y<=9; y++ ) {
			if (figee[x][y] != 0) {
				old_figee[n] = new Array();
				old_figee[n]["x"] = x;
				old_figee[n]["y"] = y;
				old_figee[n]["valeur"] = figee[x][y];
				n++ ;
			}
			add(0, "cell_" + x + "_" + y, false);
		}
	}
	initialise();
	for (i=0; i<n; i++ ) {
		add(old_figee[i]["valeur"], "cell_" + old_figee[i]["x"] + "_" + old_figee[i]["y"], false);
	}
	figer();
	test_result();
}